# Inspiration from
# https://github.com/folio-org/ui-agreements/pull/1015/commits/e44b8a380e4e5794ecc059e837d2394be600c8b2

name: buildNPM Release
on:
  push:
    tags:
      - 'v[0-9]+.[0-9]+.[0-9]+*'
  workflow_dispatch:


jobs:
  github-actions-ci:
    if : ${{ startsWith(github.ref, 'refs/tags/v') }}
    env:
      ILL_NPM_REGISTRY: 'https://nexus.libsdev.k-int.com/repository/libsdev-npm-hosted/'
      FOLIO_NPM_REGISTRY: 'https://repository.folio.org/repository/npm-folio/'
      NODEJS_VERSION: '14'

    runs-on: ubuntu-latest
    steps:
      - uses: folio-org/checkout@v2
        with:
          fetch-depth: 0

      # Runs a single command using the runners shell
      - name: Print tag info
        run: echo "Building release tag, ${GITHUB_REF}"

      - name: Set TAG_VERSION
        run: echo "TAG_VERSION=$(echo ${GITHUB_REF#refs/tags/v})" >> $GITHUB_ENV

      - name: Get version from package.json
        id: package_version
        uses: notiz-dev/github-action-json-property@release
        with:
          path: 'package.json'
          prop_path: 'version'

      - name: Check matching tag and version in package.json
        if: ${{ env.TAG_VERSION != steps.package_version.outputs.prop }}
        run: |
          echo "Tag version, ${TAG_VERSION}, does not match package.json version, ${PACKAGE_VERSION}."
          exit 1
        env:
          PACKAGE_VERSION: ${{ steps.package_version.outputs.prop }}

      - name: Set yarn config for FOLIO
        run: yarn config set @folio:registry $FOLIO_NPM_REGISTRY

      - name: Set yarn config for ILL
        run: yarn config set @folio:registry $FOLIO_NPM_REGISTRY

      - name: Set _auth in .npmrc
        run: |
          npm config set @k-int:registry $ILL_NPM_REGISTRY
          npm config set -- //nexus.libsdev.k-int.com/repository/libsdev-npm-snapshots-hosted/:_authToken=$NODE_AUTH_TOKEN
          echo run whoami for $ILL_NPM_REGISTRY
          npm --registry $ILL_NPM_REGISTRY whoami
        env:
          NODE_AUTH_TOKEN: ${{ secrets.ILL_NPM_RELEASE_TOKEN }}

      - name: Run yarn install
        run: yarn install --ignore-scripts

      - name: Run yarn list
        run: yarn list --pattern @folio
        run: yarn list --pattern @k-int

      - name: Run yarn lint
        run: yarn lint
        continue-on-error: true

      - name: Publish NPM to FOLIO NPM registry
        run: npm publish
        env:
          NODE_AUTH_TOKEN: ${{ secrets.ILL_NPM_RELEASE_TOKEN }}
